


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

   package require htmlparse

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable MaxDrives 4
    variable TapeServerState 0
    variable Storage 0
    variable InUse
    variable DriveInfo

    for {set i 0} {$i < $MaxDrives} {incr i} {
      set InUse(TAP$i) 0
    }

    variable ErrorStatus
    set ErrorStatus(0)    "No Error"
    set ErrorStatus(1)    "Device already in use"
    set ErrorStatus(8)    "Invalid Access Token"
    set ErrorStatus(14)   "Client ID already in use"
    set ErrorStatus(6)    "Device already allocated"
    set ErrorStatus(7)    "Device not in correct state for action"
    set ErrorStatus(3)    "Cannot issue more Access Tokens"
    set ErrorStatus(13)   "Server not in correct state for action"
    set ErrorStatus(11)   "Invalid/Unknown Client ID"
    set ErrorStatus(15)   "Invalid/Unknown Device"


    variable DeviceStatus {unallocated allocated mounting mounted opening open closing executing initialising \
    identifying putting moving twelve thirteen fourteen fifteen "device error"}
 

    variable TapeDeviceList "NULL"



    variable ID "TAP0"
    variable DevName "NULL"
    variable VolN "NULL"
    variable FileN "NULL"
    variable DevStatus "Unknown"
    variable StreamState {0 0 0 0}

    variable BlocksWritten 0
    variable KbytesWritten 0
    variable DataRate 0
    variable DataPercent 0

       variable label  0
       variable density  0
       variable OldVolN "NULL"

       variable access 2
       variable label 2
       variable reclen 0
       variable blklen 0

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
    }


   proc do_inquiredevices {} {
       global errorCode errorInfo
       variable ErrorStatus
       variable TapeDeviceList 
       variable DevName

       set z [catch {::namespace inscope ::urn:TapeServer InquireAvailableDevices} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
                InsertLog "InquireAvailableDevices returned: [tail $m]"
                set TapeDeviceList {}
                set devices [tail $m]
                for {set i 0} {$i < [llength $devices]} {incr i 3} {
                    lappend TapeDeviceList "[lindex $devices [expr $i+1]]"
                }
                set DevName [first $TapeDeviceList]
           } else {
              if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireAvailableDevices returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireAvailableDevices failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_allocatedevice {} {
       variable ID
       variable DevName
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer AllocateDevice $ID $DevName} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "AllocateDevice returned: [tail $m]"
           } else {
              if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n AllocateDevice returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "AllocateDevice failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_deallocatedevice {} {
       variable ID
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer DeallocateDevice $ID} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "DeallocateDevice returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n DeallocateDevice returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "DeallocateDevice failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquiredevicestatus {} {
       variable ID
       variable DriveInfo
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireDeviceStatus $ID} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               InsertLog "InquireDeviceStatus returned: [tail $m]"
               set DriveInfo [tail $m]
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireDeviceStatus returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireDeviceStatus failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquirestreamstatus {} {
       variable ID
       variable DeviceStatus
       variable DevStatus
       variable ErrorStatus
       variable InUse
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireStreamStatus $ID} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               InsertLog "InquireStreamStatus returned: [tail $m]"
               set state [lindex [tail $m] 1]
               set DevStatus [lindex $DeviceStatus $state]
               set InUse($ID) 1
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireStreamStatus returned:- \n[::htmlparse::mapEscapes $m]"
              set InUse($ID) 0
           } 
       } else {
           InsertLog "InquireStreamStatus failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set InUse($ID) 0
       }
   }

   proc do_inquirestreamstate {s} {
       variable ID
       variable StreamState
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireStreamState $s} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               InsertLog "InquireStreamState returned: [tail $m]"
               set StreamState [tail $m]
               if {[llength $StreamState] == 1} {set StreamState [list 0 0 0 0]}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireStreamState returned:- \n[::htmlparse::mapEscapes $m]
           } 
       } else {
           InsertLog "InquireStreamState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_claim {} {
       global errorCode errorInfo
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer ClaimTapeServer} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "ClaimTapeServer returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n ClaimTapeServer returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "ClaimTapeServer failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_free {} {
       global errorCode errorInfo
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer FreeTapeServer} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "FreeTapeServer returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n FreeTapeServer returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "FreeTapeServer failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_identifyvolume {} {
       global errorCode errorInfo
       variable ID

       set z [catch {::namespace inscope ::urn:TapeServer IdentifyVolume $ID} msg]

       if {$z == 0} {
           InsertLog "IdentifyVolume returned: [lindex $msg 5]"
       } else {
           InsertLog "IdentifyVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_initialisevolume {} {
       global errorCode errorInfo
       variable ID
       variable VolN
       variable label
       variable density
       variable OldVolN

       set z [catch {::namespace inscope ::urn:TapeServer InitialiseVolume $ID $VolN $label $density $OldVolN} msg]

       if {$z == 0} {
           InsertLog "InitialiseVolume returned: [lindex $msg 5]"
       } else {
           InsertLog "InitialiseVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_mountvolume {} {
       global errorCode errorInfo
       variable ID
       variable VolN
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer MountVolume $ID $VolN} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "MountVolume returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n MountVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "MountVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_dismountvolume {} {
       global errorCode errorInfo
       variable ID
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer DismountVolume $ID} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "DismountVolume returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n DismountVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "DismountVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_openfile {} {
       global errorCode errorInfo
       variable ErrorStatus
       variable ID
       variable FileN
       variable access
       variable label
       variable reclen
       variable blklen

       set z [catch {::namespace inscope ::urn:TapeServer OpenFile $ID $access $label $reclen $blklen $FileN} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "OpenFile returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n OpenFile returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "OpenFile failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_closefile {} {
       global errorCode errorInfo
       global ErrorStatus
       variable ID

       set z [catch {::namespace inscope ::urn:TapeServer CloseFile $ID} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "CloseFile returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n CloseFile returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "CloseFile failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_inquireserverstate {} {
       global errorCode errorInfo
       global ErrorStatus
       variable TapeServerState
       variable Storage

       set z [catch {::namespace inscope ::urn:TapeServer InquireTapeServerState} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "InquireTapeServerState returned: [tail $m]"
              set TapeServerState [expr [tail $m] - 1]
              if {$TapeServerState == 0} {return}
              if {$TapeServerState == 1} {set Storage 0} else {set Storage 1; set TapeServerState 1}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireTapeServerState returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireTapeServerState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_setserverstate {} {
       global errorCode errorInfo
       global ErrorStatus
       variable TapeServerState
       variable Storage

        if {$TapeServerState == 0} {
          set state 1
        } else {
          set state [expr $TapeServerState + $Storage + 1]
        }

       set z [catch {::namespace inscope ::urn:TapeServer SetTapeServerState $state} msg]
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              InsertLog "SetTapeServerState returned: [tail $m]"
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n SetTapeServerState returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "SetTapeServerState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_update {} {
      variable DriveInfo
      variable StreamState
      variable BlocksWritten 
      variable KbytesWritten 
      variable DataRate 
      variable DataPercent 

        do_inquiredevicestatus 





        do_inquirestreamstatus

        do_inquirestreamstate 1
        set BlocksWritten [lindex $StreamState 1]
        set KbytesWritten [lindex $StreamState 2]
        set DataRate [lindex $StreamState 3]        

        do_inquireserverstate

  }

   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable DevName
       variable ID
       variable VolN
       variable FileN
       variable TapeDeviceList
       variable TapeServerState
       variable Storage


       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

            VERBOSE  {set Verbose [expr ($Verbose + 1) & 1]}

            INQUIREDEVICES    {do_inquiredevices}
            CLAIM             {do_claim}
            FREE              {do_free}
            ALLOCATE          {do_allocatedevice}
            DEALLOCATE        {do_deallocatedevice}
            INITIALISE        {do_initialisevolume}
            IDENTIFY          {do_identifyvolume}
            MOUNT             {do_mountvolume}
            DISMOUNT          {do_dismountvolume}
            OPEN              {do_openfile}
            CLOSE             {do_closefile}

            DEVNAMES -
            DEVNAME         {set DevName [lindex $w 1]; set ID "TAP[lsearch $TapeDeviceList $DevName]"}

            VOLN        {set VolN [lindex $w 1]}
            FILEN       {set FileN [lindex $w 1]}

            SERVERSTATE    {set TapeServerState [lindex $w 1]; do_setserverstate}
            STORAGE        {
                if {[lindex $w 1] == "true"} {set Storage 1} else {set Storage 0}
                do_setserverstate
            }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       do_update
    }

}   ;# end of if {$started == 0}



